package eu.DECIDEh2020.mcsla.editor.service;

/*
* Copyright (c) 2017 Fraunhofer FOKUS.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the
* <<licensing_schema_to_be_decided>> which accompanies
* this distribution, and is available at
* https://opensource.org/licenses/EPL-2.0
*
* Contributors:
*
* Majid Salehi Ghamsari Fraunhofer FOKUS
**Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
*/
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;

@Service("configFileService")
public class ConfigFileServiceImpl implements ConfigFileService {

	private static final String DECIDE_MCSLA_SERVICE_URL = "decide.mcsla.service.url";

	@Value("${decide.mcsla.service.url:http://localhost:8080/decide.mcsla.srv}")
	private String serviceUrl;

	@Autowired
	private Environment environment;

	/**
	 * @param serviceURL
	 *            the serviceURL to set
	 */
	public void setServiceURL(String serviceURL) {
		this.serviceUrl = serviceURL;
	}

	public String getServiceUrl() {
		String url = environment.getProperty(DECIDE_MCSLA_SERVICE_URL);
		if (url != null) {
			System.out.println("ConfigFileServiceImpl:getServiceUrl:" + url);
			return url;
		} else
			return serviceUrl;

	}

	public void readValues() {
		System.out.println(
				"Getting property via Spring Environment User:" + environment.getProperty(DECIDE_MCSLA_SERVICE_URL));
	}

}
