package eu.DECIDEh2020.mcsla.service.service;

/*
* Copyright (c) 2017 Fraunhofer FOKUS.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the
* <<licensing_schema_to_be_decided>> which accompanies
* this distribution, and is available at
* https://opensource.org/licenses/EPL-2.0
*
* Contributors:
*
* Majid Salehi Ghamsari Fraunhofer FOKUS
**Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
*/
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;

@Service("configFileService")
public class ConfigFileServiceImpl implements ConfigFileService {

	private static final String DECIDE_APP_GIT_REMOTE_PATH = "decide.app.git.remote-path";
	private static final String DECIDE_APP_GIT_USER_NAME = "decide.app.git.user-name";
	private static final String DECIDE_APP_GIT_USER_PASSWORD = "decide.app.git.user-password";
	@Value("${decide.app.git.remote-path:https://gitlab.fokus.fraunhofer.de/decide/test.git}")
	private String gitremotepath;
	@Value("${decide.app.git.user-name:decideuser}")
	private String gitusername;
	@Value("${decide.app.git.user-password:decidepassword}")
	private String gituserpassword;

	@Autowired
	private Environment environment;

	public String getGitremotepath() {
		String envRemotepath = environment.getProperty(DECIDE_APP_GIT_REMOTE_PATH);
		if (envRemotepath != null)
			return envRemotepath;
		else
			return gitremotepath;

	}

	public String getGitusername() {
		String envUsername = environment.getProperty(DECIDE_APP_GIT_USER_NAME);
		if (envUsername != null)
			return envUsername;
		else
			return gitusername;
	}

	public String getGituserpassword() {
		String envUserpassword = environment.getProperty(DECIDE_APP_GIT_USER_PASSWORD);
		if (envUserpassword != null)
			return envUserpassword;
		else
			return gituserpassword;
	}

	public void readValues() {
		System.out.println(
				"Getting property via Spring Environment User:" + environment.getProperty(DECIDE_APP_GIT_USER_NAME));
		System.out.println("Getting property via Spring Environment Remotepath:"
				+ environment.getProperty(DECIDE_APP_GIT_REMOTE_PATH));
		System.out.println("Destination gitremotepath : " + gitremotepath);
		System.out.println("Destination gitusername : " + gitusername);
		//System.out.println("Destination gituserpassword : " + gituserpassword);

	}

	public void setGitremotepath(String gitremotepath) {
		this.gitremotepath = gitremotepath;
	}

	public void setGitusername(String gitusername) {
		this.gitusername = gitusername;
	}

	public void setGituserpassword(String gituserpassword) {
		this.gituserpassword = gituserpassword;
	}

}
