package eu.DECIDEh2020.mcsla.service.tests;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;
import java.util.UUID;

import org.eclipse.jgit.api.errors.CanceledException;
import org.eclipse.jgit.api.errors.ConcurrentRefUpdateException;
import org.eclipse.jgit.api.errors.DetachedHeadException;
import org.eclipse.jgit.api.errors.GitAPIException;
import org.eclipse.jgit.api.errors.InvalidConfigurationException;
import org.eclipse.jgit.api.errors.InvalidRemoteException;
import org.eclipse.jgit.api.errors.NoFilepatternException;
import org.eclipse.jgit.api.errors.NoHeadException;
import org.eclipse.jgit.api.errors.NoMessageException;
import org.eclipse.jgit.api.errors.RefNotFoundException;
import org.eclipse.jgit.api.errors.WrongRepositoryStateException;

import eu.DECIDEh2020.mcsla.beans.Mcsla;
import eu.DECIDEh2020.mcsla.service.git.GitControl;

public class TestGit {

	public static void main(String[] args) throws IOException, GitAPIException {

		Mcsla mcsla = new Mcsla(UUID.randomUUID(), "this is MCSLA3 description line.", "public",
				"this is MCSLA3 setValidityPeriod line.");
		pushToRepo(mcsla);

		getFromRepo();

	}

	private static void getFromRepo()
			throws IOException, NoFilepatternException, GitAPIException, FileNotFoundException, NoHeadException,
			NoMessageException, ConcurrentRefUpdateException, WrongRepositoryStateException, InvalidRemoteException,
			InvalidConfigurationException, DetachedHeadException, CanceledException, RefNotFoundException {

		GitControl gc = new GitControl();
		// Push to repository
		Mcsla mcsla = gc.getMcslaFromRepo();
		System.out.println("TestGit:getFromRepo:" + mcsla.getmCSLA_id());
	}

	private static void pushToRepo(Mcsla mcsla)
			throws IOException, NoFilepatternException, GitAPIException, FileNotFoundException, NoHeadException,
			NoMessageException, ConcurrentRefUpdateException, WrongRepositoryStateException, InvalidRemoteException,
			InvalidConfigurationException, DetachedHeadException, CanceledException, RefNotFoundException {

		GitControl gc = new GitControl();
		// Push to repository
		gc.pushMcslaToRepo(mcsla);
	}

	@SuppressWarnings("unused")
	private static String getProperty(String key) {
		Properties prop = new Properties();
		InputStream input = null;
		String value = null;
		try {

			String propertiesfilename = "application.properties";
			input = TestGit.class.getClassLoader().getResourceAsStream(propertiesfilename);
			if (input == null) {
				System.out.println("Sorry, unable to find properties file:" + propertiesfilename);
				return null;
			}

			prop.load(input);

			value = prop.getProperty(key);

		} catch (IOException ex) {
			ex.printStackTrace();
		} finally {
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
		return value;
	}

}